﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Init(object sender, EventArgs e)
    {
        Repeater1.DataSource = new string[] { "1", "2", "3", "4" };
        Repeater1.DataBind();
        Repeater2.DataSource = new string[] { "1", "2", "3", "4" };
        Repeater2.DataBind();
    }

    protected void Repeater1_ItemCreated(object sender, RepeaterItemEventArgs e)
    {
        var placeHolder = e.Item.FindControl("myPlaceHolder1") as PlaceHolder;

        var combo = new RadComboBox();
        combo.ID = "RadComboBoxRegion";
        combo.RenderMode = RenderMode.Lightweight;
        combo.MinFilterLength = 1;
        combo.Height = 200;
        combo.Width = 315;
        combo.EnableLoadOnDemand = true;
        combo.EmptyMessage = "Choose a Region";
        combo.WebServiceSettings.Path = "Territories.asmx";
        combo.WebServiceSettings.Method = "GetTerritories";

        placeHolder.Controls.Add(combo);
    }

    protected void Repeater2_ItemCreated(object sender, RepeaterItemEventArgs e)
    {
        var placeHolder = e.Item.FindControl("myPlaceHolder1") as PlaceHolder;

        var combo = new RadComboBox();
        combo.ID = "RadComboBoxProduct";
        combo.RenderMode = RenderMode.Lightweight;
        combo.MinFilterLength = 1;
        combo.Height = 200;
        combo.Width = 315;
        combo.EnableLoadOnDemand = true;
        combo.EmptyMessage = "Choose a Product";
        combo.ItemsRequested += RadComboBoxProduct_ItemsRequested;

        placeHolder.Controls.Add(combo);
    }

    protected void RadComboBoxProduct_ItemsRequested(object sender, RadComboBoxItemsRequestedEventArgs e)
    {
        string sqlSelectCommand = "SELECT [ProductID], [ProductName], [UnitPrice], [UnitsInStock] from [Products] WHERE [ProductName] LIKE @text + '%' ORDER BY [ProductName]";

        SqlDataAdapter adapter = new SqlDataAdapter(sqlSelectCommand,
            ConfigurationManager.ConnectionStrings["NorthwindConnectionString"].ConnectionString);
        adapter.SelectCommand.Parameters.AddWithValue("@text", e.Text);
        DataTable dataTable = new DataTable();
        adapter.Fill(dataTable);

        foreach (DataRow dataRow in dataTable.Rows)
        {
            RadComboBoxItem item = new RadComboBoxItem();

            item.Text = (string)dataRow["ProductName"];
            item.Value = dataRow["ProductID"].ToString();

            decimal unitPrice = (decimal)dataRow["UnitPrice"];
            short unitsInStock = (short)dataRow["UnitsInStock"];

            item.Attributes.Add("UnitPrice", unitPrice.ToString());
            item.Attributes.Add("UnitsInStock", unitsInStock.ToString());

            item.Value += ":" + unitPrice;

            (sender as RadComboBox).Items.Add(item);

            item.DataBind();
        }
    }
}
